<script setup lang="ts">

import Posts from "@/components/Posts.vue";
import Menu from 'primevue/menu'
import { computed, ref } from 'vue'
import { type Post } from '@/models'

const posts = ref<Post[]>([])

const menuItems = computed(() => {
  return posts.value?.map((post) => ({
    label: post.title,
    route: `/post/${post.id}`,
  }));
})

fetch('https://jsonplaceholder.typicode.com/posts')
  .then((response) => response.json())
  .then((json) => {
    posts.value = json;
  });
</script>

<template>
  <div class="my-blog">
    <main>
      <h1>My Blog</h1>
      <Posts :posts/>
    </main>
    <aside>
      <h2>Posts</h2>
      <Menu :model="menuItems">
        <template #item="{ item, props }">
          <router-link v-if="item.route" v-slot="{ href, navigate }" :to="item.route" custom>
            <a v-ripple :href="href" v-bind="props.action" @click="navigate">
              <span :class="item.icon" />
              <span class="ml-2">{{ item.label }}</span>
            </a>
          </router-link>
          <a v-else v-ripple :href="item.url" :target="item.target" v-bind="props.action">
            <span :class="item.icon" />
            <span class="ml-2">{{ item.label }}</span>
          </a>
        </template>
      </Menu>
    </aside>
  </div>
</template>

<style scoped>
  .my-blog {
    display: grid;
    grid-template-columns: 75% 25%;
    grid-column-gap: 10px;
    padding: 0 10px;
  }
</style>
